//
//  AntiColViewController.m
//  AreteCap
//
//  Created by Asterisk on 2015/02/20.
//
//

#import "AntiColViewController.h"

@interface AntiColViewController ()<RcpRfidDelegate>

@property (weak, nonatomic) IBOutlet UITableView *myTableView;
@property (strong,nonatomic) NSArray *modeList;
@property (assign,nonatomic) NSInteger selectedMode;
@property (weak, nonatomic) IBOutlet UITextField *startText;
@property (weak, nonatomic) IBOutlet UITextField *maxText;
@property (weak, nonatomic) IBOutlet UITextField *minText;
@property (weak, nonatomic) IBOutlet UISegmentedControl *modeSec;
@property (weak, nonatomic) IBOutlet UIView *fixedView;
@end

@implementation AntiColViewController

- (void)viewWillAppear:(BOOL)animated{
    [super viewWillAppear:animated];
    
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.startText.text = [NSString stringWithFormat:@"%d",(int)self.start];
    self.maxText.text = [NSString stringWithFormat:@"%d",(int)self.max];
    self.minText.text = [NSString stringWithFormat:@"%d",(int)self.min];
    if (self.mode == 0x00) {
        self.fixedView.hidden = NO;
        self.modeSec.selectedSegmentIndex = 0;
    }else{
        self.fixedView.hidden = YES;
        self.modeSec.selectedSegmentIndex = 1;
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}


- (IBAction)changeMode:(id)sender {
    if (_modeSec.selectedSegmentIndex == 0) {
        _fixedView.hidden = NO;
    }else{
        _fixedView.hidden = YES;
    }
}

- (IBAction)done:(id)sender {
    
    dispatch_async(dispatch_get_main_queue(), ^{
        uint8_t mode ;
        if (_modeSec.selectedSegmentIndex == 0) {
            mode = 0x00;
        }else{
            mode = 0x01;
        }
        
        uint8_t start = [self hexIntwithString:_startText.text];
        uint8_t max = [self hexIntwithString:_maxText.text];
        uint8_t min = [self hexIntwithString:_minText.text];
        
        [self.rcp setAnticollision:mode qStart:start qMax:max qMin:min];

    });
}

- (unsigned int)hexIntwithString:(NSString*)lenStr{
    
    NSScanner*scan = [NSScanner scannerWithString:lenStr];
    unsigned int length;
    [scan scanHexInt:&length];
    return length;
}

@end
