//
//  EpcViewController.m
//  AreteCapDongle
//
//  Created by 小田和哉 on 2016/02/15.
//
//

#import "EpcViewController.h"
#import "PhyUtility.h"


@interface EpcViewController ()<RcpRfidDelegate,UITextFieldDelegate>
@property (weak, nonatomic) IBOutlet UITextField *targetLabel;
@property (weak, nonatomic) IBOutlet UITextField *inputText;
@property (weak, nonatomic) IBOutlet UITextField *inputHex;
@property (weak, nonatomic) IBOutlet UITextField *hexLabel;

@end

@implementation EpcViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.rcp.delegate = self;
    self.inputHex.delegate=self;
    self.targetLabel.text = [self.epc bytesToHexString];
    self.inputHex.text = [self.epc bytesToHexString];
    self.inputText.text = [self.epc bytesToCharString];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
 #pragma mark - Navigation
 
 // In a storyboard-based application, you will often want to do a little preparation before navigation
 - (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
 // Get the new view controller using [segue destinationViewController].
 // Pass the selected object to the new view controller.
 }
 */
- (IBAction)done:(id)sender {
    if ([self.inputText.text isEqualToString:@""]) {
        UIAlertView *alert =  [[UIAlertView alloc]initWithTitle:nil message:@"Please input Data." delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
        [alert show];
        return;
    }
    
    //    [self.rcp writeToTagMemory:self.pcEpc dataToWriteAscii:self.inputText.text];
    BOOL status = [self.rcp writeToTagMemory:self.pcEpc dataToWriteHex:self.inputHex.text];
    if (!status) {
        UIAlertView *alert =  [[UIAlertView alloc]initWithTitle:nil message:@"Parameter error." delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
        [alert show];
    }
}

- (void)writedReceived:(uint8_t)statusCode{
    dispatch_async(dispatch_get_main_queue(), ^{
        UIAlertView *alert = [[UIAlertView alloc]initWithTitle:nil message:@"Writed." delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
        [alert show];
        
        
        //        [self.rcp readFromTagMemory:0x00000000 epc:[self.inputText.text dataUsingEncoding:NSUTF8StringEncoding]
        //                         memoryBank:0x01 startAddress:0x00 dataLength:0x00];
        NSString * writeHex=self.inputHex.text;
        if (self.inputHex.text.length%2!=0) {
            writeHex=[writeHex stringByAppendingString:@"0"];
        }
        [self.rcp readFromTagMemory:0x00000000 epc:[writeHex hexStringToBytes]
                         memoryBank:0x01 startAddress:0x00 dataLength:0x00];
    });
}

-(void)tagMemoryReceived:(NSData *)data{
    
    
    
    dispatch_async(dispatch_get_main_queue(), ^{
        self.pcEpc = [data subdataWithRange:NSMakeRange(2, data.length - 2)];;
        self.epc = [data subdataWithRange:NSMakeRange(4, data.length - 4)];
        
        /*
         UIAlertView *alert = [[UIAlertView alloc]initWithTitle:nil message:[NSString stringWithFormat:@"Readed.\n%@",self.epc] delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
         [alert show];
         */
        
        self.targetLabel.text = [self.epc bytesToHexString];
        //        self.inputHex.text = [self.epc bytesToHexString];
        //        self.inputText.text = [self.epc bytesToCharString];
    });
    
    
    
}

- (void)errDetailReceived:(NSData *)errCode{
    
    if (errCode.length < 3) return;
    
    Byte *b = (Byte*) [errCode bytes];
    
    NSString *title = @"";
    
    if (b[1] == 0x29) {
        title = @"Read";
        dispatch_async(dispatch_get_main_queue(), ^{
            //            self.targetLabel.text = @"";
        });
    }else if (b[1] == 0x46){
        title = @"Write";
        dispatch_async(dispatch_get_main_queue(), ^{
            //            self.targetLabel.text = @"";
        });
    }
    

    dispatch_async(dispatch_get_main_queue(),
                   ^{
        NSString *strErrMsg = [NSString stringWithFormat:@"Error Code: [0x%02X]\nSub Error Code:[0x%02X]", b[0],b[2]];
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:[NSString stringWithFormat:@"%@ Error",title]
                                                        message:strErrMsg
                                                       delegate:nil
                                              cancelButtonTitle:@"OK"
                                              otherButtonTitles:nil];
        
                       [alert show];
                   });
}
- (IBAction)changedHex:(id)sender {
    self.inputText.text = [[self.inputHex.text hexStringToBytes] bytesToCharString];
}

- (IBAction)changedText:(id)sender {
    self.inputHex.text = [[NSData dataWithBytes:[self.inputText.text UTF8String] length:[self.inputText.text length]] bytesToHexString];
}

- (IBAction)copyTarget:(id)sender{
    self.targetLabel.text = self.hexLabel.text;
}

- (void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    [self.targetLabel resignFirstResponder];
    [self.hexLabel resignFirstResponder];
    [self.inputText resignFirstResponder];
}
- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string {
    
    NSCharacterSet* nonHex = [[NSCharacterSet
                               characterSetWithCharactersInString: @"0123456789ABCDEFabcdef"]
                              invertedSet];
    NSRange nonHexRange = [string rangeOfCharacterFromSet:nonHex];
    BOOL isHex = (nonHexRange.location == NSNotFound);
    
    if (isHex) {
        NSString *newString = [textField.text stringByReplacingCharactersInRange:range withString:string];
        textField.text = [newString uppercaseString];
    }
    return NO;
}
@end
