//
//  LockController.m
//  AretePop
//
//  Created by Asterisk on 13. 6. 20..
//
//

#import "LockController.h"
#import "Utility.h"

@interface LockController ()

@end

@implementation LockController
@synthesize rcp = _rcp;
@synthesize epc = _epc;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    self.rcp.delegate = self;    
    self.olTargetEpc.text = [self.epc bytesToHexString];    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)rightBarButtonItemClicked:(id)sender
{
    [self.olTargetEpc resignFirstResponder];
    
    NSString *hexaString = self.olAccessPassword.text;
    NSScanner* pScanner = [NSScanner scannerWithString: hexaString];
    uint32_t accesspassword;
    [pScanner scanHexInt: &accesspassword];
    
    uint32_t lock = 0;
    uint32_t seed = (uint32_t)self.olAction.selectedSegmentIndex;
        
    switch (self.olTargetMemory.selectedSegmentIndex)
    {
        case 0: // Kill
            lock = (seed << 8) | (3 << 18);
            break;
        case 1: // Access
            lock = (seed << 6) | (3 << 16);
            break;
        case 2: // EPC
            lock = (seed << 4) | (3 << 14);
            break;  
        case 3: // TID
            lock = (seed << 2) | (3 << 12);
            break;
        case 4: // USER
            lock = (seed << 0) | (3 << 10);
            break;
        default:
            break;
    }
    
    [self.rcp lockTagMemory:accesspassword
                        epc:self.epc
                   lockData:lock];
    
}

- (void)errReceived:(uint8_t)errCode
{
    NSString *strErrMsg = [NSString stringWithFormat:@"Error Code: %d", errCode];
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                    message:strErrMsg
                                                   delegate:nil
                                          cancelButtonTitle:@"OK"
                                          otherButtonTitles:nil];
    
    dispatch_async(dispatch_get_main_queue(),
    ^{
            [alert show];
    });
}

- (void)lockedReceived:(uint8_t)statusCode{
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"StatusCode"
                                                    message:@"設定が反映されました"
                                                   delegate:nil
                                          cancelButtonTitle:@"OK"
                                          otherButtonTitles:nil];
    
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       [alert show];
                   });
}

- (void)viewDidUnload {
    [self setOlTargetEpc:nil];
    [self setOlAccessPassword:nil];
    [self setOlTargetMemory:nil];
    [self setOlAction:nil];
    [super viewDidUnload];
}
@end
